﻿using System;

namespace VTableNamespace
{
    public partial class VTable
    {
        /// <summary>
        /// Tablica zawierajaca elementy klasy Value, ktorej rozmiar jest ustalany w kontruktorze klasy VTable
        /// i jest wspolny dla wszystkich tablic klasy Array uzywanych przez klase VTable
        /// </summary>
        class Array
        {
            /// <summary>Pole - rozmiar tablicy</summary>
            private int Size;

            /// <summary>Pole - tablica</summary>
            private Value[] A;

            /// <summary>Konstruktor klasy Array</summary>
            /// <param name="size">Rozmiar tablicy</param>
            public Array(int size)
            {
                Size = size;
                A = new Value[Size];

                for (int colIdx = 0; colIdx < Size; colIdx++)
                {
                    A[colIdx] = new Value();
                }
            }

            /// <summary>Wlasnosc umozliwiwajaca zmiane i pobranie elementu tablicy</summary>
            /// <param name="colIdx">Indeks elementu klasy Value w tablicy</param>
            /// <returns>Element tablicy</returns>
            public Value this[int colIdx]
            {
                set
                {
                    if (colIdx >= 0 && colIdx < Size)
                    {
                        A[colIdx] = value;
                    }
                    else
                    {
                        throw new Exception(GetType().DeclaringType.Name + " column index error");
                    }
                }

                get
                {
                    if (colIdx >= 0 && colIdx < Size)
                    {
                        return A[colIdx];
                    }
                    else
                    {
                        throw new Exception(GetType().DeclaringType.Name + " column index error");
                    }
                }
            }
        }
    }
}