﻿using System.Collections.Generic;

namespace VTableNamespace
{
    public partial class VTable
    {
        /// <summary>Metoda zmieniajaca polozenie elementu Value w tablicy Array</summary>
        /// <param name="colFrom">Pierwotny indeks elementu w tablicy</param>
        /// <param name="colTo">Nowy indeks elementu w tablicy</param>
        /// <param name="row">Indeks tablicy na liscie</param>
        public void ShiftFromTo(int colFrom, int colTo, int row)
        {
            this[colTo, row].AsStr = this[colFrom, row].AsStr;
            this[colFrom, row].AsStr = "";
            this[colTo, row].AsInt = this[colFrom, row].AsInt;
            this[colFrom, row].AsInt = 0;
        }

        /// <summary>
        /// Metoda przesuwajaca elementy tablicy klasy Array
        /// najpierw tworzaca liste indeksow ostatnich w tablicy elementow klasy Value
        /// ktore sa typu string o dlugosci zero,
        /// a nastepnie przesuwajaca je poczawszy od ostatnich indeksow w strone indeksow wyzszych
        /// </summary>
        /// <param name="widthsMatrix">
        /// Macierz pozycjonujaca, zawieraca sumy dlugosci dla poszczegolnych indeksow elementow Value
        /// oraz ilosci scalonych komorek tabeli Word wyliczone przez motode SumOfWidths klasy TableHeader
        /// </param>
        public void ShiftCells(VTable widthsMatrix)
        {
            List<int> EmptyLast = new List<int>();

            for (int rowIdx = 0; rowIdx < this.RowCount; rowIdx++)
            {
                if (this[ColumnCount - 1, rowIdx].AsStr == "")
                {
                    EmptyLast.Add(rowIdx);
                }
            }

            foreach (int rowIdx in EmptyLast)
            {
                for (int colIdx = 0; colIdx < this.ColumnCount - 2; colIdx++)
                {
                    if (this[colIdx, rowIdx].AsStr != "")
                    {
                        int shiftRight = 0;
                        int matrixRowIdx = 0;

                        while (this[colIdx, rowIdx].AsInt > widthsMatrix[colIdx, colIdx + matrixRowIdx].AsInt)
                        {
                            matrixRowIdx++;
                            shiftRight++;
                        }

                        if (shiftRight > 0)
                        {
                            for (int overWidthColIdx = this.ColumnCount - 2; overWidthColIdx > colIdx; overWidthColIdx--)
                            {
                                int newColIdx = overWidthColIdx + shiftRight;

                                if (newColIdx < this.Size)
                                {
                                    this.ShiftFromTo(overWidthColIdx, newColIdx, rowIdx);
                                }
                            }
                        }
                    }
                }
            }
        }
    }
}

